#define DEF_PAL 1	/* Default medium-res palette */
#define DEF_BACK 8	/* Default background color */
#define DEF_MUT 200	/* Default mutation period */
#define ExTest(Test,Mess) (Test && (fputs(Mess,stderr), exit(2)))
#define FLAG_SPECS "-"	/* '-' specifies a flag */
#define MAX_CELLS 1024	/* Max num of cells - width of highest-res display */

typedef struct l {  /* List of arg strings parsed from lines in arg file */
   char *Args[8];   /* Args - only 8 different args are possible */
   int NumArgs;
   struct l *Next;
} ParamList;
typedef struct e {	/* Used to create a list of lca environments */
   int Bytes,	/* Number of bytes of cells */
   Rules[10],	/* Initial cell generating rules */
   Gens,	/* Number of generations of cell to produce using this envrn */
   MutPeriod,	/* Number of generations between mutations */
   Scroll,	/* Whether to scroll or not */
   VidMode,	/* Video mode */
   LineNap, ScreenNap,	/* naps between each line & screen */
   Background,	/* Background color */
   Palette;	/* Color palette */
   /* Packed representation of initial cell values (4 cells/byte) */
   unsigned char PackedCells[MAX_CELLS >> 2];
   struct e *Next;
} EnvListType;

int TranslateParams(ParamList *Params,EnvListType *EnvList);
int RestoreMode(void);
int GetVidMode(void);
int SetVidMode(int *VidMode,int *Cols,int *Rows);
int SetPalette(int Palette,int Background);
int InterpretFlags(char *Args[],int Num,int *Background,int *Palette,
int *Width,int Rules[],int *Gens,int *MutPeriod,int *Scroll,int *VidMode,
int *LineNap,int *ScreenNap,int Cells[],ParamList *Params);
int GetParams(char *FileName,ParamList *Params);
int GetArgs(char *S,char *Args[],int *NumArgs,int MaxArgs);
void *MallocT(unsigned Size);
int RandInit(int Ints[],int Num,int Max);
int CharToInt(int *Ints,char *Chars,int NumInts,int HighestInt);
int Min(int I1,int I2);
void RemoveFlagSpecs(char *Args[],int Num,char FlagSpecs[]);
void PrintStrings(char *Strings[]);
void MakePacked(int Cells[],unsigned char PackedCells[],int Width);
void GotoXY(unsigned x,unsigned y);
void CursorLoc(int *x,int *y);
int SaveSetMode(int Mode);
void ScrollUp(int Bytes,int Line);
void DriveLCA(EnvListType *EnvList);
void LCA(int Byte,unsigned char PackedCells[],int Rules[],int Gens,
 int MutPeriod,int Scroll,int LineNap, int ScreenNap);
long Tone(int Freq,long Period);
int SetGraphicsMode(void);
int RestoreVid(void);

#ifdef __TURBOC__
#define CharPending() bioskey(1)
#else
#define CharPending() rdchk(0)
#endif
