/* john h. dubois iii   last rev 5/4/90 */
#include <termio.h>
#include <stdio.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/fcntl.h>
#include <sys/sysmacros.h>
#include <sys/console.h>
#include "clca.h"

int SavedVidMode;
int GraphicsMode;
struct termio TTYMode;
char *VidBase;
int VidDev = 0;
char *VidMem;
char VidBuf[200][80];

int RestoreMode(void)
/* Restores video and tty modes as saved by SaveMode */
{
    return (RestoreVid() || ioctl(0,TCSETA,&TTYMode) == -1);
}

int RestoreVid(void)
{
    return ioctl(VidDev,MODESWITCH | SavedVidMode,0) == -1;
}

SaveMode(void)
{
    return (SavedVidMode = ioctl(VidDev,CONS_GET,0)) == -1 || 
    ioctl(0,TCGETA,&TTYMode) == -1;
}

Gocbreak(void)
{
    struct termio T;

    T = TTYMode;
    T.c_lflag &= !(ECHO | ICANON);
    T.c_cc[VMIN] = 1;
    T.c_cc[VTIME] = 0;
    return (ioctl(0,TCSETA,&T) == -1);
}

int SetGraphicsMode(void) {
    return ioctl(VidDev,GraphicsMode,0) == -1;
}

int SetVidMode(VidMode,Cols,Rows)
int *VidMode;
int *Cols,*Rows;
{
    switch (ioctl(0,CONS_CURRENT,0)) {
    case VGA:
	if (*VidMode == VGA) {
	    *Cols = 640;
	    *Rows = 480;
	    GraphicsMode = SW_VGA11;
	    break;
	}
    case EGA:
	if ((*VidMode == VGA) || (*VidMode == EGA)) {
	    *Cols = 640;
	    *Rows = 350;
	    GraphicsMode = SW_CG640x350;
	    *VidMode = EGA;
	    break;
	}
    case CGA:
	*Cols = 320;
	*Rows = 200;
	GraphicsMode = SW_CG320;
	*VidMode = CGA;
	break;
    case MONO:
    case -1:
    default:
	return(1);
    }
    if (SetGraphicsMode())
	return -1;
    if ((int) (VidBase = (char *) ioctl(VidDev,MAPCONS,0)) == -1)
	return -1;
    return 0;
}

int SetPalette(int Palette,int Background)
/* Sets medium - res palette to Palette and background color to Background */
/* Palette 0: 0 = background color; 1 = Green; 2 = Red; 3 = Brown.
    Palette 1: 0 = background color; 1 = Cyan; 2 = Magenta; 3 = White.
    Background: 4 bits; format IRGB (intesity, red, green, blue) */
{
    return(0);
}

void GotoXY(unsigned x,unsigned y)
/* Move cursor to position x,y */
{
}

void CursorLoc(int *x,int *y)
/* Get current cursor location */
{
}

void ScrollUp(Bytes,Line)
/* Scrolls the graphics screen up one line. */
int Bytes;
int Line;
{
    int L;
    char *Page1 = VidBase - 80;
    char *Page2 = VidBase + 0x2000 - 80;

    for (L = 100; L; L--) {
	memcpy(Page1 += 80,VidBuf[Line++],Bytes);
	if (Line == 200)
	    Line = 0;
	memcpy(Page2 += 80,VidBuf[Line++],Bytes);
	if (Line == 200)
	    Line = 0;
    }
}

BufferCells(PackedCells,Bytes,Line)
void *PackedCells;
size_t Bytes;
int Line;
{
    memcpy(VidBuf[Line],PackedCells,Bytes);
}

DrawCells(PackedCells,Bytes,Line)
char *PackedCells;
int Bytes;
int Line;
{
    memcpy(VidBase + (Line>>1)*80 + (Line & 1 ? 0x2000 : 0),PackedCells,Bytes);
}
